import scala.io.Source

// A regular expression to match Apache HTTP web server logs:
val WebLog = """(.*) - - \[(.*)\] \"(.*) (.*)\" (.*) .*""".r

// A table:
var table = Set[String]()

// A counter:
var counter = 0

// Failed/Successful Requests:
var failed = 0
var success = 0

println("Searching")
for (line <- Source.fromFile("NASA_access_log_Jul95.txt").getLines()) {
  val WebLog(origin, date, method, path, status) = line
  table = table + origin
  counter += 1
  if (status == "200") success += 1
  if (status == "404") failed += 1
  if (counter % 100 == 0) print("#")
}

println(s"\nfound ${table.size} unique origins out of $counter requests")
println(s"Success (200): $success")
println(s"Failed (404): $failed")
println(s"Other: ${counter-success+failed}")
println("%2.2f%% success hit rate".format((success.toFloat/counter)*100))
println("%2.2f%% failure hit rate".format((failed.toFloat/counter)*100))
println("%2.2f%% other hit rate".format(((counter-success+failed).toFloat/counter)*100))